/*
 * Copyright (c) 1993 by the University of Southern California
 *
 * For copying and distribution information, please see the file
 * <usc-copyr.h>.
 *
 * The menu API and client were written by Kwynn Buess (buess@isi.edu)
 */

#include <usc-copyr.h>



#include "menu.h"
#include <string.h>
#include <pfs.h>                /* for p_set_sw_id() */

main(int argc,char *argv[]) { 
  int choice;
  VLINK temp;
  MCS mcstruct_ptr;
  extern int pfs_debug;
  MCS *mc = &mcstruct_ptr;


  /* Set the software ID for this client. */
  /* If you are developing a Prospero client, please send email to
     info-prospero@isi.edu to get your own software ID. */
  p_set_sw_id("mPtb");          
  printf("\n\nProspero Menu Browser\n\n");

  argc--; argv++;

  if (argc > 0) 
    if (!strncmp(argv[0], "-D", 2)) {
      pfs_debug = 9;
      argc--;argv++;
    }
  
/*
      pfs_debug = 1;
      sscanf(argv[1], "-D%d", &pfs_debug);
*/
  init_menu(mc,set_environ(argc,argv));
  while (1) { 
    print_current_menu(mc);
    choice = query_choice(mc);

    if (choice == -1) continue;

/*    if (choice == -1) {
      really_quit();
    }
    else if (choice == -2) printf("\nINVALID CHOICE.  TRY AGAIN.\n");
*/
/*else*/    if (choice == 0) { 
      if (!top_menu(mc)) up_menu(mc);
      else printf("\nThere are no higher menus.\n");
    } 
    else {
      temp = return_choice(choice,mc);
      if (temp == NULL) printf("\nINVALID CHOICE.  TRY AGAIN.\n");
      else if (m_class(temp) == M_CLASS_MENU
               || m_class(temp) == M_CLASS_SEARCH) { 
	if (m_class(temp) == M_CLASS_MENU) get_menu(mc,temp);
        else get_search(mc,temp);
	if (is_empty(mc)) { 
	  up_menu(mc);
          if (m_class(temp) == M_CLASS_MENU)
              printf("\nNO FILES IN %s!  REPEATING PREVIOUS MENU...\n",
                     m_item_description(temp));
          else 
              printf("No files were found as a result of the search %s. \
Repeating previous menu.\n", m_item_description(temp));
	} /* if empty */
      } /* if menu */
      else if (m_class(temp) == M_CLASS_DOCUMENT) open_and_display(temp);
      else if (m_class(temp) == M_CLASS_PORTAL) open_telnet(temp);
      else if (m_class(temp) == M_CLASS_DATA) open_data(temp);
      else printf("\nThis type is not implemented yet.\n");
    } /* if choice > * */
  } /* infinite loop */
} /* main() */



